restaurant/urls.py
from django.urls import path
from .views import page_not_found, forbidden

from .views import (
    IndexView,
    DishTypeListView,
    DishTypeDetailView,
    DishTypeCreateView,
    DishTypeUpdateView,
    DishTypeDeleteView,
    DishListView,
    DishDetailView,
    DishCreateView,
    DishUpdateView,
    DishDeleteView,
    CookListView,
    CookDetailView,
    CookCreateView,
    CookDeleteView,
)


urlpatterns = [
    path(
        "", IndexView.as_view(), name="index"
    ),
    path(
        "dish_types/", DishTypeListView.as_view(), name="dish-type-list"
    ),
    path(
        "dish_types/<int:pk>/",
        DishTypeDetailView.as_view(),
        name="dish-type-detail"
    ),
    path(
        "dish_types/create",
        DishTypeCreateView.as_view(),
        name="dish-type-create"
    ),
    path(
        "dish_types/<int:pk>/update/",
        DishTypeUpdateView.as_view(),
        name="dish-type-update"
    ),
    path(
        "dish_types/<int:pk>/delete/",
        DishTypeDeleteView.as_view(),
        name="dish-type-delete"
    ),
    path(
        "dishes/", DishListView.as_view(), name="dish-list"
    ),
    path(
        "dishes/<int:pk>/", DishDetailView.as_view(), name="dish-detail"
    ),
    path(
        "dishes/create/", DishCreateView.as_view(), name="dish-create"
    ),
    path(
        "dishes/<int:pk>/update/", DishUpdateView.as_view(), name="dish-update"
    ),
    path(
        "dishes/<int:pk>/delete/", DishDeleteView.as_view(), name="dish-delete"
    ),
    path(
        "cooks/", CookListView.as_view(), name="cook-list"
    ),
    path(
        "cooks/<int:pk>/", CookDetailView.as_view(), name="cook-detail"
    ),
    path(
        "cooks/create/", CookCreateView.as_view(), name="cook-create"
    ),
    path(
        "cooks/<int:pk>/delete/", CookDeleteView.as_view(), name="cook-delete"
    ),
    path(
        "404/", page_not_found, name="404"
    ),
    path(
        "403/", forbidden, name="403"
    ),
]

app_name = "restaurant"

restaurant_service/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("restaurant.urls", namespace="restaurant")),
    path("accounts/", include("django.contrib.auth.urls")),
    path("__debug__/", include("debug_toolbar.urls")),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

handler404 = "restaurant.views.page_not_found"
handler403 = "restaurant.views.forbidden"

restaurant/models.py
from django.contrib.auth.models import AbstractUser
from django.db import models
from django.utils.translation import gettext_lazy as _
from django.urls import reverse

from restaurant_service import settings


class DishType(models.Model):
    name = models.CharField(max_length=63, unique=True)

    class Meta:
        ordering = ["name"]

    def __str__(self):
        return self.name


class Dish(models.Model):
    name = models.CharField(max_length=63, unique=True)
    description = models.TextField()
    price = models.DecimalField(max_digits=6, decimal_places=2)
    dish_type = models.ForeignKey(
        to=DishType,
        related_name="dishes",
        on_delete=models.CASCADE
    )
    cooks = models.ManyToManyField(
        to=settings.AUTH_USER_MODEL,
        related_name="dishes"
    )

    class Meta:
        ordering = ["name"]
        verbose_name_plural = "dishes"

    def __str__(self):
        return self.name


class Cook(AbstractUser):
    years_of_experience = models.PositiveIntegerField(default=0)
    is_staff = models.BooleanField(
        _("staff status"),
        default=True,
        help_text=_(
            "Designates whether the user can log into this admin site."
        ),
    )

    class Meta:
        verbose_name = "cook"
        verbose_name_plural = "cooks"
        ordering = ["username"]

    def __str__(self):
        return f"{self.username} ({self.first_name} {self.last_name})"

    def get_absolute_url(self):
        return reverse("restaurant:cook-detail", kwargs={"pk": self.pk})

restaurant/forms.py
from django import forms
from django.contrib.auth import get_user_model
from django.contrib.auth.forms import UserCreationForm
from django.core.exceptions import ValidationError

from restaurant.models import Dish, Cook, DishType

MAX_EXPERIENCE = 60


class DishForm(forms.ModelForm):
    cooks = forms.ModelMultipleChoiceField(
        queryset=get_user_model().objects.all(),
        widget=forms.CheckboxSelectMultiple,
    )

    class Meta:
        model = Dish
        fields = "__all__"


class CookCreationForm(UserCreationForm):
    class Meta(UserCreationForm.Meta):
        model = Cook
        fields = UserCreationForm.Meta.fields + (
            "years_of_experience",
            "first_name",
            "last_name",
            "is_staff",
            "is_superuser",
        )

    def clean_years_of_experience(self):
        return validate_years_of_experience(
            self.cleaned_data["years_of_experience"]
        )


def validate_years_of_experience(years_of_experience):
    if years_of_experience > MAX_EXPERIENCE:
        raise ValidationError(
            f"Years of experience cannot be more than {MAX_EXPERIENCE}"
        )
    return years_of_experience


class SearchForm(forms.Form):
    search = "param"

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields[self.search] = forms.CharField(
            max_length=255,
            required=False,
            label="",
            widget=forms.TextInput(
                attrs={"placeholder": f"Search by {self.search}..."}
            ),
        )


class CookSearchForm(SearchForm):
    search = "username"


class DishTypeSearchForm(SearchForm):
    search = "name"


class DishSearchForm(SearchForm):
    search = "name"


class DishTypeFilterForm(forms.Form):
    dish_type = forms.ModelMultipleChoiceField(
        queryset=DishType.objects.all(),
        required=False,
        label="By dish type",
        widget=forms.CheckboxSelectMultiple(
            attrs={"class": "form-check-input"}
        )
    )

restaurant/views.py
from django.contrib.auth import get_user_model
from django.urls import reverse_lazy
from django.views import View, generic
from django.shortcuts import render

from restaurant.forms import (
    CookCreationForm,
    CookSearchForm,
    DishSearchForm,
    DishTypeSearchForm,
    DishForm,
    DishTypeFilterForm
)
from restaurant.mixins import (
    IsStaffMixin,
    IsSuperUserMixin,
    CookDetailIfIsStaffMixin
)
from restaurant.models import Dish, DishType, Cook


class IndexView(View):
    template_name = "restaurant/index.html"

    def get(self, request):
        num_cooks = get_user_model().objects.count()
        num_dishes = Dish.objects.count()
        num_dish_types = DishType.objects.count()
        num_visits = request.session.get("num_visits", 0)
        request.session["num_visits"] = num_visits + 1

        context = {
            "num_cooks": num_cooks,
            "num_dishes": num_dishes,
            "num_dish_types": num_dish_types,
            "num_visits": num_visits + 1,
        }

        return render(request, self.template_name, context=context)


class CookListView(IsStaffMixin, generic.ListView):
    model = get_user_model()
    paginate_by = 10

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(CookListView, self).get_context_data(**kwargs)
        username = self.request.GET.get("username", "")
        context["search_form"] = CookSearchForm(
            initial={"username": username}
        )

        return context

    def get_queryset(self):

        if self.request.user.is_superuser:
            queryset = get_user_model().objects.all()
        else:
            queryset = get_user_model().objects.filter(is_superuser=False)

        form = CookSearchForm(self.request.GET)

        if form.is_valid():
            return queryset.filter(
                username__icontains=form.cleaned_data["username"]
            )

        return queryset


class CookDetailView(CookDetailIfIsStaffMixin, generic.DetailView):
    model = Cook
    queryset = Cook.objects.prefetch_related("dishes__dish_type")


class CookCreateView(IsSuperUserMixin, generic.CreateView):
    model = Cook
    form_class = CookCreationForm


# class CookUpdateView(IsSuperUserMixin, generic.UpdateView):
#     model = Cook
#     success_url = reverse_lazy("restaurant:cook-list")


class CookDeleteView(IsSuperUserMixin, generic.DeleteView):
    model = Cook
    success_url = reverse_lazy("restaurant:cook-list")


class DishListView(generic.ListView):
    model = Dish
    paginate_by = 10

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(DishListView, self).get_context_data(**kwargs)
        name = self.request.GET.get("name", "")
        dish_type_ids = self.request.GET.getlist("dish_type", "")
        context["search_form"] = DishSearchForm(
            initial={"name": name}
        )

        context["dish_type_filter_form"] = DishTypeFilterForm(
            initial={"dish_type": dish_type_ids}
        )
        return context

    def get_queryset(self):
        queryset = Dish.objects.select_related("dish_type")
        form = DishSearchForm(self.request.GET)
        dish_type_ids = self.request.GET.getlist("dish_type")

        if form.is_valid():
            queryset = queryset.filter(
                name__icontains=form.cleaned_data["name"]
            )
        if dish_type_ids:
            queryset = queryset.filter(dish_type_id__in=dish_type_ids)

        return queryset


class DishDetailView(generic.DetailView):
    model = Dish


class DishCreateView(IsSuperUserMixin, generic.CreateView):
    model = Dish
    form_class = DishForm
    success_url = reverse_lazy("restaurant:dish-list")


class DishUpdateView(IsStaffMixin, generic.UpdateView):
    model = Dish
    form_class = DishForm
    success_url = reverse_lazy("restaurant:dish-list")


class DishDeleteView(IsSuperUserMixin, generic.DeleteView):
    model = Dish
    success_url = reverse_lazy("restaurant:dish-list")


class DishTypeListView(generic.ListView):
    model = DishType
    context_object_name = "dish_type_list"
    template_name = "restaurant/dish_type_list.html"
    paginate_by = 10

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(DishTypeListView, self).get_context_data(**kwargs)
        name = self.request.GET.get("name", "")
        context["search_form"] = DishTypeSearchForm(
            initial={"name": name}
        )

        return context

    def get_queryset(self):
        queryset = DishType.objects.all()
        form = DishTypeSearchForm(self.request.GET)

        if form.is_valid():
            return queryset.filter(
                name__icontains=form.cleaned_data["name"]
            )

        return queryset


class DishTypeDetailView(generic.DetailView):
    model = DishType
    context_object_name = "dish_type"
    template_name = "restaurant/dish_type_detail.html"


class DishTypeCreateView(IsSuperUserMixin, generic.CreateView):
    model = DishType
    fields = "__all__"
    template_name = "restaurant/dish_type_form.html"
    success_url = reverse_lazy("restaurant:dish-type-list")


class DishTypeUpdateView(IsSuperUserMixin, generic.UpdateView):
    model = DishType
    fields = "__all__"
    template_name = "restaurant/dish_type_form.html"
    success_url = reverse_lazy("restaurant:dish-type-list")


class DishTypeDeleteView(IsSuperUserMixin, generic.DeleteView):
    model = DishType
    template_name = "restaurant/dish_type_confirm_delete.html"
    success_url = reverse_lazy("restaurant:dish-type-list")


def page_not_found(request, exception):
    return render(request, 'errors/404.html', status=404)


def forbidden(request, exception):
    return render(request, 'errors/403.html', status=403)

templates/restaurant/cook_confirm_delete.html
{% extends "base.html" %}

{% block content %}
  <div class="d-flex justify-content-center">
    <div>
      <h1 class="text-white text-center font-weight-bold">Delete cook?</h1>
      <form action="" method="post">
        {% csrf_token %}
        <div class="text-center">
          <input type="submit" value="Yes" class="btn btn-danger">
          <a href="{% url 'restaurant:cook-list' %}" class="btn btn-primary link-to-page">
            No
          </a>
        </div>
      </form>
    </div>
  </div>
{% endblock %}

templates/restaurant/cook_detail.html
{% extends "base.html" %}

{% block content %}
  <h1 class="text-white font-weight-bold">
    Username: {{ cook.username }}
    {% if user.is_superuser %}
      <a href="{% url 'restaurant:cook-delete' pk=cook.id %}" class="btn btn-danger link-to-page float-right">
        Delete
      </a>
    {% endif %}
  </h1>

  <h3 class="text-white ml-5"><strong>First name:</strong> {{ cook.first_name }}</h3>
  <h3 class="text-white ml-5"><strong>Last name:</strong> {{ cook.last_name }}</h3>
  <h3 class="text-white ml-5"><strong>Experience in years:</strong> {{ cook.years_of_experience }}</h3>
  <h3 class="text-white ml-5"><strong>Is staff:</strong> {{ cook.is_staff }}</h3>
  <h3 class="text-white ml-5"><strong>Is super:</strong> {{ cook.is_superuser }}</h3>
  <br>

<div class="mt-3">
  <h1 class="text-white text-center font-weight-bold">Dishes</h1>
  <br>
  <div class="row">
    {% for dish in cook.dishes.all %}
      <div class="col-md-3 mb-4">
        <div class="card table-border background-box">
          <div class="card-body">
            <h5 class="card-title">Dish id: {{ dish.id }}</h5>
            <p class="card-text">
              <strong>Name:</strong>
              <a href="{% url 'restaurant:dish-detail' pk=dish.id %}" class="link-style">
                {{ dish.name }}
              </a>
            </p>
            <p class="card-text">
              <strong>Dish type:</strong>
              <a href="{% url 'restaurant:dish-type-detail' pk=dish.dish_type.id %}" class="link-style">
                {{ dish.dish_type.name }}
              </a>
            </p>
          </div>
        </div>
      </div>
    {% empty %}
      <h2 class="text-white ml-3">No dishes!</h2>
    {% endfor %}
  </div>
</div>
{% endblock %}

templates/restaurant/cook_form.html
{% extends "base.html" %}
{% load crispy_forms_filters %}

{% block content %}
  <h1 class="text-white text-center font-weight-bold">Create cook</h1>
  <div class="table-border justify-content-center p-2 background-box">
  <form action="" method="post" novalidate>
    {% csrf_token %}
    {{ form|crispy }}
    <div class="container">
      <div class="row justify-content-center align-items-center">
        <input type="submit" value="Submit" class="btn btn-primary">
      </div>
    </div>
  </form>
  </div>
{% endblock %}

templates/restaurant/cook_list.html
{% extends "base.html" %}
{% load crispy_forms_filters %}

{% block content %}
  <h1 class="text-center font-weight-bold text-white">
    Cook List
    {% if user.is_superuser %}
      <a href="{% url 'restaurant:cook-create' %}" class="btn btn-primary link-to-page float-right mt-2">
        Create
      </a>
  {% endif %}
</h1>
<br>
{% block search %}
  {% include "includes/search.html" %}
{% endblock %}
<br>
{% if cook_list %}
<table class="table table-info table-border">
  <tr>
    <th>ID</th>
    <th>Username</th>
    <th>First name</th>
    <th>Last name</th>
    <th>Experience(in years)</th>
  </tr>
{% for cook in cook_list %}
  <tr>
    <td>{{ cook.id }}</td>
    <td>
      <a href="{{ cook.get_absolute_url }}" class="link-style">{{ cook.username }} </a>
    </td>
    <td>{{ cook.first_name }}</td>
    <td>{{ cook.last_name }}</td>
    <td>{{ cook.years_of_experience }}</td>
  </tr>
{% endfor %}

</table>
{% else %}
  <p>There are no cooks in the restaurant.</p>
{% endif %}
{% endblock %}

templates/restaurant/dish_confirm_delete.html
{% extends "base.html" %}

{% block content %}
  <div class="d-flex justify-content-center">
    <div>
      <h1 class="text-white text-center font-weight-bold">Delete dish?</h1>
      <form action="" method="post">
        {% csrf_token %}
        <div class="text-center">
          <input type="submit" value="Yes" class="btn btn-danger">
          <a href="{% url 'restaurant:dish-list' %}" class="btn btn-primary link-to-page">
            No
          </a>
        </div>
      </form>
    </div>
  </div>
{% endblock %}

templates/restaurant/dish_detail.html
{% extends "base.html" %}

{% block content %}
  <h1 class="text-white text-center">
    {{ dish.name }}
    {% if user.is_superuser %}
      <a href="{% url 'restaurant:dish-delete' pk=dish.id %}" class="btn btn-danger link-to-page float-right">
        Delete
      </a>
    {% endif %}
    {% if user.is_staff %}
      <a href="{% url 'restaurant:dish-update' pk=dish.id %}" class="btn btn-secondary link-to-page float-right">

        Update
      </a>
    {% endif %}
  </h1>
  <br>
  <h3 class="text-white"><strong>Dish type:</strong> {{ dish.dish_type.name }}</h3>
  <h5 class="text-white ml-4"><strong>Price:</strong> {{ dish.price }}</h5>
  <h5 class="text-white ml-4"><strong>Description:</strong> {{ dish.description }}</h5>
  <br>
  <h1 class="text-white">
    Cooks
  </h1>
  <div class="container">
    <div class="row">
      <div class="col-3">
        <div class="card table-border background-box">
          <div>
            <ul>
              {% for cook in dish.cooks.all %}
                <li>
                  <a href="{% url 'restaurant:cook-detail' pk=cook.id %}" class="link-style">
                    {{ cook.username }}
                    <p>({{ cook.first_name }} {{ cook.last_name }})</p>
                  </a>
                </li>
              {% endfor %}
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>

{% endblock %}

templates/restaurant/dish_form.html
{% extends "base.html" %}
{% load crispy_forms_filters %}

{% block content %}
  <h1 class="text-center text-white font-weight-bold">{{ object|yesno:"Update,Create" }} dish</h1>
  <div class="table-border justify-content-center p-2 background-box">
  <form action="" method="post" novalidate>
    {% csrf_token %}
    {{ form|crispy }}
    <div class="container">
      <div class="row justify-content-center align-items-center">
        <input type="submit" value="Submit" class="btn btn-primary">
      </div>
    </div>
  </form>
  </div>
{% endblock %}

templates/restaurant/dish_list.html
{% extends "base.html" %}
{% load crispy_forms_filters %}
{% block filter %}
  <div class="filter-position">
    {% include "includes/sidebar.html" %}
  </div>
{% endblock %}
{% block content %}
  <h1 class="text-center font-weight-bold text-white">
    Dish List
  </h1>
  {% if user.is_superuser %}
    <a href="{% url 'restaurant:dish-create' %}" class="btn btn-primary link-to-page float-right">
      Create
    </a>
   {% endif %}

  <br>

  {% include 'includes/search.html' %}

  <br>

    {% if dish_list %}
      <table class="table table-info table-border">
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Price in USD$</th>
          <th>Dish type</th>
          {% if user.is_staff %}
            <th>Update</th>
          {% endif %}
          {% if user.is_superuser %}
            <th>Delete</th>
          {% endif %}
        </tr>
        {% for dish in dish_list %}
          <tr>
            <td>
              {{ dish.id }}
            </td>
            <td>
              <a href="{% url "restaurant:dish-detail" pk=dish.id %}" class="link-style">
                {{ dish.name }}
              </a>
            </td>
            <td>
              {{ dish.price }}
            </td>
            <td>
              <a href="{% url "restaurant:dish-type-detail" pk=dish.dish_type.id %}" class="link-style">
                {{ dish.dish_type.name }}
              </a>
            </td>
            {% if user.is_staff %}
              <td>
                <a href="{% url 'restaurant:dish-update' pk=dish.id %}" class="link-update">
                  Update
                </a>
              </td>
            {% endif %}
            {% if user.is_superuser %}
              <td>
                <a href="{% url 'restaurant:dish-delete' pk=dish.id %}" class="link-delete">
                  Delete
                </a>
              </td>
            {% endif %}
          </tr>
        {% endfor %}
      </table>
    {% else %}
      <p>There are no dishes in the restaurant</p>
    {% endif %}
{% endblock %}

templates/restaurant/dish_type_confirm_delete.html
{% extends "base.html" %}

{% block content %}
  <div class="d-flex justify-content-center">
    <div>
      <h1 class="text-white text-center font-weight-bold">Delete dish type?</h1>
      <form action="" method="post">
        {% csrf_token %}
        <div class="text-center">
          <input type="submit" value="Yes" class="btn btn-danger">
          <a href="{% url 'restaurant:dish-type-list' %}" class="btn btn-primary link-to-page">
            No
          </a>
        </div>
      </form>
    </div>
  </div>
{% endblock %}

templates/restaurant/dish_type_detail.html
{% extends "base.html" %}

{% block content %}
  <h1 class="text-white text-center font-weight-bold">
    {{ dish_type.name }}
    {% if user.is_superuser %}
      <a href="{% url 'restaurant:dish-type-delete' pk=dish_type.id %}" class="btn btn-danger link-to-page float-right">
        Delete
      </a>

      <a href="{% url 'restaurant:dish-type-update' pk=dish_type.id %}" class="btn btn-secondary link-to-page float-right">
        Update
      </a>
    {% endif %}
  </h1>
  <br>
  <h1 class="text-white">
    Dishes
  </h1>
  <br>
  <div class="container">
    <div class="row">
      <div class="col-3">
        <div class="card table-border background-box">
          <div>
            <ul>
              {% for dish in dish_type.dishes.all %}
                <br>
                <li>
                  <a href="{% url "restaurant:dish-detail" pk=dish.id %}" class="link-style">
                    {{ dish.name }}
                  </a>
                </li>
              {% endfor %}
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>

{% endblock %}

templates/restaurant/dish_type_form.html
{% extends "base.html" %}
{% load crispy_forms_filters %}

{% block content %}
  <h1 class="text-white text-center font-weight-bold">{{ object|yesno:"Update,Create" }} dish type</h1>
  <div class="table-border justify-content-center p-2 background-box">
  <form action="" method="post" novalidate>
    {% csrf_token %}
    {{ form|crispy }}
    <div class="container">
      <div class="row justify-content-center align-items-center">
        <input type="submit" value="Submit" class="btn btn-primary">
      </div>
    </div>
  </form>
  </div>
{% endblock %}

templates/restaurant/dish_type_list.html
{% extends "base.html" %}
{% load crispy_forms_filters %}

{% block content %}
  <h1 class="text-center font-weight-bold text-white">
    Dish Type List
    {% if cook.is_superuser %}
      <a href="{% url 'restaurant:dish-type-create' %}" class="btn btn-primary link-to-page float-right">
        Create
      </a>
    {% endif %}
  </h1>
  <br>

  {% include "includes/search.html" %}

  <br>
  {% if dish_type_list %}
    <table class="table table-info table-border">
      <tr>
        <th>ID</th>
        <th>Name</th>
        <th>Number of dishes</th>
        {% if user.is_superuser %}
          <th>Update</th>
          <th>Delete</th>
        {% endif %}
      </tr>

      {% for dish_type in dish_type_list %}
        <tr>
          <td>
              {{ dish_type.id }}
          </td>
          <td>
            <a href="{% url 'restaurant:dish-type-detail' pk=dish_type.id %}" class="link-style">
              {{ dish_type.name }}
            </a>
          </td>
          <td>
            {{ dish_type.dishes.count }}
          </td>
          {% if user.is_superuser %}
            <td>
              <a href="{% url 'restaurant:dish-type-update' pk=dish_type.id %}" class="link-update">
                Update
              </a>
            </td>
            <td>
              <a href="{% url 'restaurant:dish-type-delete' pk=dish_type.id %}" class="link-delete">
                Delete
              </a>
            </td>
          {% endif %}
        </tr>
      {% endfor %}
    </table>

  {% else %}
      <p>There are no dish types in the service.</p>
  {% endif %}
{% endblock %}

templates/restaurant/index.html
{% extends "base.html" %}

{% block content %}
  <div class="d-flex justify-content-center align-items-center">
    <div class="g-transparent text-white">
      <h1 class="font-weight-bold">Restaurant Service Home</h1>
      <p>Welcome to Best Restaurant Ever!</p>
      <h2>The restaurant content</h2>
      <p>The restaurant has the following:</p>
      <ul>
          <li><strong>Dishes:</strong> {{ num_dishes }}</li>
          <li><strong>Cooks:</strong> {{ num_cooks }}</li>
          <li><strong>Dish Types:</strong> {{ num_dish_types }}</li>
      </ul>

      <p>You have visited this page
          {{ num_visits }} time{{ num_visits|pluralize }}.
      </p>
    </div>
  </div>
{% endblock %}